// Code generated by moq; DO NOT EDIT.
// github.com/matryer/moq

package application

import (
	"gitlab.com/uprefer/ustore/base"
	"gitlab.com/uprefer/ustore/errors"
	"sync"
)

var (
	lockiServiceMockCreate       sync.RWMutex
	lockiServiceMockDelete       sync.RWMutex
	lockiServiceMockGetAll       sync.RWMutex
	lockiServiceMockGetResource  sync.RWMutex
	lockiServiceMockRecordExists sync.RWMutex
	lockiServiceMockUpdate       sync.RWMutex
)

// Ensure, that iServiceMock does implement iService.
// If this is not the case, regenerate this file with moq.
var _ iService = &iServiceMock{}

// iServiceMock is a mock implementation of iService.
//
//     func TestSomethingThatUsesiService(t *testing.T) {
//
//         // make and configure a mocked iService
//         mockediService := &iServiceMock{
//             CreateFunc: func(m base.IModel) (base.IModel, errors.Error) {
// 	               panic("mock out the Create method")
//             },
//             DeleteFunc: func(id string) errors.Error {
// 	               panic("mock out the Delete method")
//             },
//             GetAllFunc: func(id string) ([]base.IModel, errors.Error) {
// 	               panic("mock out the GetAll method")
//             },
//             GetResourceFunc: func(id string) (base.IModel, errors.Error) {
// 	               panic("mock out the GetResource method")
//             },
//             RecordExistsFunc: func(id string) bool {
// 	               panic("mock out the RecordExists method")
//             },
//             UpdateFunc: func(m base.IModel) (base.IModel, errors.Error) {
// 	               panic("mock out the Update method")
//             },
//         }
//
//         // use mockediService in code that requires iService
//         // and then make assertions.
//
//     }
type iServiceMock struct {
	// CreateFunc mocks the Create method.
	CreateFunc func(m base.IModel) (base.IModel, errors.Error)

	// DeleteFunc mocks the Delete method.
	DeleteFunc func(id string) errors.Error

	// GetAllFunc mocks the GetAll method.
	GetAllFunc func(id string) ([]base.IModel, errors.Error)

	// GetResourceFunc mocks the GetResource method.
	GetResourceFunc func(id string) (base.IModel, errors.Error)

	// RecordExistsFunc mocks the RecordExists method.
	RecordExistsFunc func(id string) bool

	// UpdateFunc mocks the Update method.
	UpdateFunc func(m base.IModel) (base.IModel, errors.Error)

	// calls tracks calls to the methods.
	calls struct {
		// Create holds details about calls to the Create method.
		Create []struct {
			// M is the m argument value.
			M base.IModel
		}
		// Delete holds details about calls to the Delete method.
		Delete []struct {
			// ID is the id argument value.
			ID string
		}
		// GetAll holds details about calls to the GetAll method.
		GetAll []struct {
			// ID is the id argument value.
			ID string
		}
		// GetResource holds details about calls to the GetResource method.
		GetResource []struct {
			// ID is the id argument value.
			ID string
		}
		// RecordExists holds details about calls to the RecordExists method.
		RecordExists []struct {
			// ID is the id argument value.
			ID string
		}
		// Update holds details about calls to the Update method.
		Update []struct {
			// M is the m argument value.
			M base.IModel
		}
	}
}

// Create calls CreateFunc.
func (mock *iServiceMock) Create(m base.IModel) (base.IModel, errors.Error) {
	if mock.CreateFunc == nil {
		panic("iServiceMock.CreateFunc: method is nil but iService.Create was just called")
	}
	callInfo := struct {
		M base.IModel
	}{
		M: m,
	}
	lockiServiceMockCreate.Lock()
	mock.calls.Create = append(mock.calls.Create, callInfo)
	lockiServiceMockCreate.Unlock()
	return mock.CreateFunc(m)
}

// CreateCalls gets all the calls that were made to Create.
// Check the length with:
//     len(mockediService.CreateCalls())
func (mock *iServiceMock) CreateCalls() []struct {
	M base.IModel
} {
	var calls []struct {
		M base.IModel
	}
	lockiServiceMockCreate.RLock()
	calls = mock.calls.Create
	lockiServiceMockCreate.RUnlock()
	return calls
}

// Delete calls DeleteFunc.
func (mock *iServiceMock) Delete(id string) errors.Error {
	if mock.DeleteFunc == nil {
		panic("iServiceMock.DeleteFunc: method is nil but iService.Delete was just called")
	}
	callInfo := struct {
		ID string
	}{
		ID: id,
	}
	lockiServiceMockDelete.Lock()
	mock.calls.Delete = append(mock.calls.Delete, callInfo)
	lockiServiceMockDelete.Unlock()
	return mock.DeleteFunc(id)
}

// DeleteCalls gets all the calls that were made to Delete.
// Check the length with:
//     len(mockediService.DeleteCalls())
func (mock *iServiceMock) DeleteCalls() []struct {
	ID string
} {
	var calls []struct {
		ID string
	}
	lockiServiceMockDelete.RLock()
	calls = mock.calls.Delete
	lockiServiceMockDelete.RUnlock()
	return calls
}

// GetAll calls GetAllFunc.
func (mock *iServiceMock) GetAll(id string) ([]base.IModel, errors.Error) {
	if mock.GetAllFunc == nil {
		panic("iServiceMock.GetAllFunc: method is nil but iService.GetAll was just called")
	}
	callInfo := struct {
		ID string
	}{
		ID: id,
	}
	lockiServiceMockGetAll.Lock()
	mock.calls.GetAll = append(mock.calls.GetAll, callInfo)
	lockiServiceMockGetAll.Unlock()
	return mock.GetAllFunc(id)
}

// GetAllCalls gets all the calls that were made to GetAll.
// Check the length with:
//     len(mockediService.GetAllCalls())
func (mock *iServiceMock) GetAllCalls() []struct {
	ID string
} {
	var calls []struct {
		ID string
	}
	lockiServiceMockGetAll.RLock()
	calls = mock.calls.GetAll
	lockiServiceMockGetAll.RUnlock()
	return calls
}

// GetResource calls GetResourceFunc.
func (mock *iServiceMock) GetResource(id string) (base.IModel, errors.Error) {
	if mock.GetResourceFunc == nil {
		panic("iServiceMock.GetResourceFunc: method is nil but iService.GetResource was just called")
	}
	callInfo := struct {
		ID string
	}{
		ID: id,
	}
	lockiServiceMockGetResource.Lock()
	mock.calls.GetResource = append(mock.calls.GetResource, callInfo)
	lockiServiceMockGetResource.Unlock()
	return mock.GetResourceFunc(id)
}

// GetResourceCalls gets all the calls that were made to GetResource.
// Check the length with:
//     len(mockediService.GetResourceCalls())
func (mock *iServiceMock) GetResourceCalls() []struct {
	ID string
} {
	var calls []struct {
		ID string
	}
	lockiServiceMockGetResource.RLock()
	calls = mock.calls.GetResource
	lockiServiceMockGetResource.RUnlock()
	return calls
}

// RecordExists calls RecordExistsFunc.
func (mock *iServiceMock) RecordExists(id string) bool {
	if mock.RecordExistsFunc == nil {
		panic("iServiceMock.RecordExistsFunc: method is nil but iService.RecordExists was just called")
	}
	callInfo := struct {
		ID string
	}{
		ID: id,
	}
	lockiServiceMockRecordExists.Lock()
	mock.calls.RecordExists = append(mock.calls.RecordExists, callInfo)
	lockiServiceMockRecordExists.Unlock()
	return mock.RecordExistsFunc(id)
}

// RecordExistsCalls gets all the calls that were made to RecordExists.
// Check the length with:
//     len(mockediService.RecordExistsCalls())
func (mock *iServiceMock) RecordExistsCalls() []struct {
	ID string
} {
	var calls []struct {
		ID string
	}
	lockiServiceMockRecordExists.RLock()
	calls = mock.calls.RecordExists
	lockiServiceMockRecordExists.RUnlock()
	return calls
}

// Update calls UpdateFunc.
func (mock *iServiceMock) Update(m base.IModel) (base.IModel, errors.Error) {
	if mock.UpdateFunc == nil {
		panic("iServiceMock.UpdateFunc: method is nil but iService.Update was just called")
	}
	callInfo := struct {
		M base.IModel
	}{
		M: m,
	}
	lockiServiceMockUpdate.Lock()
	mock.calls.Update = append(mock.calls.Update, callInfo)
	lockiServiceMockUpdate.Unlock()
	return mock.UpdateFunc(m)
}

// UpdateCalls gets all the calls that were made to Update.
// Check the length with:
//     len(mockediService.UpdateCalls())
func (mock *iServiceMock) UpdateCalls() []struct {
	M base.IModel
} {
	var calls []struct {
		M base.IModel
	}
	lockiServiceMockUpdate.RLock()
	calls = mock.calls.Update
	lockiServiceMockUpdate.RUnlock()
	return calls
}
